"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _react = _interopRequireWildcard(require("react"));

var _isEqual = _interopRequireDefault(require("lodash/isEqual"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _useFormApi2 = _interopRequireDefault(require("@data-driven-forms/react-form-renderer/use-form-api"));

var _fieldArray = _interopRequireDefault(require("@data-driven-forms/react-form-renderer/field-array"));

var _Bullseye = require("@patternfly/react-core/dist/js/layouts/Bullseye/Bullseye.js");

var _Button = require("@patternfly/react-core/dist/js/components/Button/Button.js");

var _Flex = require("@patternfly/react-core/dist/js/layouts/Flex/Flex.js");

var _FlexItem = require("@patternfly/react-core/dist/js/layouts/Flex/FlexItem.js");

var _FormFieldGroup = require("@patternfly/react-core/dist/js/components/Form/FormFieldGroup.js");

var _FormFieldGroupHeader = require("@patternfly/react-core/dist/js/components/Form/FormFieldGroupHeader.js");

var _FormHelperText = require("@patternfly/react-core/dist/js/components/Form/FormHelperText.js");

var _Grid = require("@patternfly/react-core/dist/js/layouts/Grid/Grid.js");

var _GridItem = require("@patternfly/react-core/dist/js/layouts/Grid/GridItem.js");

var _trashIcon = _interopRequireDefault(require("@patternfly/react-icons/dist/js/icons/trash-icon"));

require("./final-form-array.css");

var _useFieldApi2 = _interopRequireDefault(require("@data-driven-forms/react-form-renderer/use-field-api"));

var _excluded = ["remove"],
    _excluded2 = ["remove"],
    _excluded3 = ["arrayValidator", "label", "description", "fields", "defaultItem", "meta", "minItems", "maxItems", "noItemsMessage", "buttonLabels"];

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) { symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { (0, _defineProperty2["default"])(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

var Spacer = function Spacer() {
  return /*#__PURE__*/_react["default"].createElement("span", {
    className: "ddf-final-form-spacer"
  });
};

var ArrayItem = /*#__PURE__*/(0, _react.memo)(function (_ref) {
  var fields = _ref.fields,
      fieldIndex = _ref.fieldIndex,
      name = _ref.name,
      remove = _ref.remove,
      length = _ref.length,
      minItems = _ref.minItems,
      buttonLabels = _ref.buttonLabels,
      isLast = _ref.isLast;

  var _useFormApi = (0, _useFormApi2["default"])(),
      renderForm = _useFormApi.renderForm;

  var editedFields = fields.map(function (field, index) {
    var computedName = field.name ? "".concat(name, ".").concat(field.name) : name;
    return _objectSpread(_objectSpread({}, field), {}, {
      name: computedName,
      key: "".concat(name, "-").concat(index)
    });
  });
  var isRemoveDisabled = length <= minItems;
  return /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, /*#__PURE__*/_react["default"].createElement(_Flex.Flex, null, /*#__PURE__*/_react["default"].createElement(_FlexItem.FlexItem, {
    className: "pf-c-form",
    grow: {
      "default": 'flex_1'
    }
  }, editedFields.map(function (field) {
    return renderForm([field]);
  })), /*#__PURE__*/_react["default"].createElement(_FlexItem.FlexItem, null, editedFields[0].label && /*#__PURE__*/_react["default"].createElement(Spacer, null), /*#__PURE__*/_react["default"].createElement(_Button.Button, (0, _extends2["default"])({
    variant: "plain",
    "aria-label": buttonLabels.remove,
    disabled: isRemoveDisabled
  }, !isRemoveDisabled && {
    onClick: function onClick() {
      return remove(fieldIndex);
    }
  }), /*#__PURE__*/_react["default"].createElement(_trashIcon["default"], null)))), !isLast && editedFields.length > 1 && /*#__PURE__*/_react["default"].createElement("hr", {
    className: "ddf-final-form-hr"
  }));
}, function (_ref2, _ref3) {
  var _prevRemove = _ref2.remove,
      prev = (0, _objectWithoutProperties2["default"])(_ref2, _excluded);
  var _nextRemove = _ref3.remove,
      next = (0, _objectWithoutProperties2["default"])(_ref3, _excluded2);
  return (0, _isEqual["default"])(prev, next);
});
ArrayItem.propTypes = {
  name: _propTypes["default"].string,
  fieldIndex: _propTypes["default"].number.isRequired,
  fields: _propTypes["default"].arrayOf(_propTypes["default"].object),
  remove: _propTypes["default"].func.isRequired,
  length: _propTypes["default"].number,
  minItems: _propTypes["default"].number,
  buttonLabels: _propTypes["default"].shape({
    remove: _propTypes["default"].node
  }),
  isLast: _propTypes["default"].bool
};

var DynamicArray = function DynamicArray(_ref4) {
  var props = (0, _extends2["default"])({}, _ref4);

  var _useFieldApi = (0, _useFieldApi2["default"])(props),
      arrayValidator = _useFieldApi.arrayValidator,
      label = _useFieldApi.label,
      description = _useFieldApi.description,
      formFields = _useFieldApi.fields,
      defaultItem = _useFieldApi.defaultItem,
      meta = _useFieldApi.meta,
      minItems = _useFieldApi.minItems,
      maxItems = _useFieldApi.maxItems,
      noItemsMessage = _useFieldApi.noItemsMessage,
      buttonLabels = _useFieldApi.buttonLabels,
      rest = (0, _objectWithoutProperties2["default"])(_useFieldApi, _excluded3);

  var dirty = meta.dirty,
      submitFailed = meta.submitFailed,
      error = meta.error,
      submitError = meta.submitError;
  var isError = (dirty || submitFailed) && (error || submitError) && (typeof error === 'string' || typeof submitError === 'string');

  var combinedButtonLabels = _objectSpread({
    add: 'Add item',
    removeAll: 'Delete all',
    remove: 'Remove'
  }, buttonLabels);

  return /*#__PURE__*/_react["default"].createElement(_fieldArray["default"], {
    key: rest.input.name,
    name: rest.input.name,
    validate: arrayValidator
  }, function (_ref5) {
    var _ref5$fields = _ref5.fields,
        map = _ref5$fields.map,
        _ref5$fields$value = _ref5$fields.value,
        value = _ref5$fields$value === void 0 ? [] : _ref5$fields$value,
        push = _ref5$fields.push,
        remove = _ref5$fields.remove,
        removeBatch = _ref5$fields.removeBatch;
    return /*#__PURE__*/_react["default"].createElement(_FormFieldGroup.FormFieldGroup, {
      header: /*#__PURE__*/_react["default"].createElement(_FormFieldGroupHeader.FormFieldGroupHeader, {
        titleText: {
          text: label,
          id: props.name
        },
        titleDescription: description,
        actions: /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, minItems === 0 && /*#__PURE__*/_react["default"].createElement(_Button.Button, (0, _extends2["default"])({
          variant: "link",
          isDisabled: value.length === 0
        }, value.length !== 0 && {
          onClick: function onClick() {
            return removeBatch(value.map(function (_, index) {
              return index;
            }));
          }
        }), combinedButtonLabels.removeAll), /*#__PURE__*/_react["default"].createElement(_Button.Button, (0, _extends2["default"])({
          variant: "secondary",
          isDisabled: value.length >= maxItems
        }, !(value.length >= maxItems) && {
          onClick: function onClick() {
            return push(defaultItem);
          }
        }), combinedButtonLabels.add))
      })
    }, value.length <= 0 && /*#__PURE__*/_react["default"].createElement(_Bullseye.Bullseye, null, noItemsMessage), map(function (name, index) {
      return /*#__PURE__*/_react["default"].createElement(ArrayItem, {
        key: "".concat(name, "-").concat(index),
        fields: formFields,
        name: name,
        fieldIndex: index,
        remove: remove,
        length: value.length,
        minItems: minItems,
        buttonLabels: combinedButtonLabels,
        isLast: value.length === index + 1
      });
    }), /*#__PURE__*/_react["default"].createElement(_Grid.Grid, null, /*#__PURE__*/_react["default"].createElement(_GridItem.GridItem, {
      sm: 11
    }, isError && /*#__PURE__*/_react["default"].createElement(_FormHelperText.FormHelperText, {
      isHidden: false,
      isError: true
    }, error || submitError))));
  });
};

DynamicArray.propTypes = {
  name: _propTypes["default"].string,
  label: _propTypes["default"].node,
  description: _propTypes["default"].node,
  fields: _propTypes["default"].arrayOf(_propTypes["default"].object).isRequired,
  defaultItem: _propTypes["default"].any,
  minItems: _propTypes["default"].number,
  maxItems: _propTypes["default"].number,
  noItemsMessage: _propTypes["default"].node,
  buttonLabels: _propTypes["default"].shape({
    add: _propTypes["default"].node,
    remove: _propTypes["default"].node,
    removeAll: _propTypes["default"].node
  })
};
DynamicArray.defaultProps = {
  maxItems: Infinity,
  minItems: 0,
  noItemsMessage: 'No items added'
};
var _default = DynamicArray;
exports["default"] = _default;